<?

function my_parse_date ($string) {

 // 0123456789
 // YYYY-MM-DD

 $YYYY = substr($string, 0, 4);
 $DD = substr($string, -2);
 $MM = substr($string, 5, 2);

 $string = $DD."-".$MM."-".$YYYY;

 $string = ereg_replace("-12-", "-Dic-", $string);
 $string = ereg_replace("-11-", "-Nov-", $string);
 $string = ereg_replace("-10-", "-Ott-", $string);
 $string = ereg_replace("-09-", "-Set-", $string);
 $string = ereg_replace("-08-", "-Ago-", $string);
 $string = ereg_replace("-07-", "-Lug-", $string);
 $string = ereg_replace("-06-", "-Giu-", $string);
 $string = ereg_replace("-05-", "-Mag-", $string);
 $string = ereg_replace("-04-", "-Apr-", $string);
 $string = ereg_replace("-03-", "-Mar-", $string);
 $string = ereg_replace("-02-", "-Feb-", $string);
 $string = ereg_replace("-01-", "-Gen-", $string);

 $string = ereg_replace("00-", "", $string);

 return $string;

}

function e ($string) {

 echo htmlspecialchars(stripslashes(quoted_printable_decode(str_replace("=\r\n","",$string))));

}

function ret_e ($string) {

 return htmlspecialchars(stripslashes(quoted_printable_decode(str_replace("=\r\n","",$string))));

}

function e_nl ($string) {

 echo nl2br(stripslashes(htmlspecialchars(quoted_printable_decode(str_replace("=\r\n","",$string)))));

}

function ret_e_nl ($string) {

 return nl2br(stripslashes(htmlspecialchars(quoted_printable_decode(str_replace("=\r\n","",$string)))));

}


function urls_clickable($string) { 

 $string = eregi_replace("(([0-9a-z]|[-_.])*)@(([[:alnum:]]|[-_.])*)", "<a href=\"mailto:\\0\">\\0</a>", $string);

 $string = ereg_replace("((ftp://)|(http://))(([[:alnum:]]|[[:punct:]])*)", "<a href=\"\\0\">\\0</a>",$string);

 return $string; 

}

function color_quote($string) {

 global $color;

 if (! $color["text_quoted"])
  $color["text_quoted"] = "#44AA88";

 $string = ereg_replace("\\*([^*]*)\\*", "<b>\\1</b>", $string);
 $string = ereg_replace("_([^*]*)_", "<u>\\1</u>", $string);

 $string = ereg_replace("(\n)([^\n]{1,10})(&gt;)([^\n]*)", "<Font Color=\"".$color["text_quoted"]."\">\\0</Font>", $string);

 return $string;

}

function write_log($str, $l) {

  if (getenv("LOG")) $logdir=getenv("log");
   else $logdir="/pub/html/webbs/log";

  error_log(date("D, d M Y H:i:s T").": ERROR : $str",3,"$logdir/$l");
}

function write_gen_log($str, $l) {

  if (getenv("LOG")) $logdir=getenv("log");
   else $logdir="./log";

  error_log("$str\r\n",3,"$logdir/$l");
}

function getsign($sDate){
	$sSign = "";
	$sMese = substr($sDate, 5, 2);
	$sGiorno = substr($sDate, 8, 2);

        if ((($sMese >= 12) and ($sGiorno >= 22)) or (($sMese <= 1) and ($sGiorno < 20)))
		$sSign = "Capricorno";
        else
        if ((($sMese >= 1)  and ($sGiorno >= 21)) or (($sMese <= 2) and ($sGiorno < 19)))
		$sSign = "Aquario";
        else
	if ((($sMese >= 2)  and ($sGiorno >= 20)) or (($sMese <= 3) and ($sGiorno < 20)))
		$sSign = "Pesci";
	else
	if ((($sMese >= 3)  and ($sGiorno >= 21)) or (($sMese <= 4) and ($sGiorno < 20)))
		$sSign = "Ariete";
	else
	if ((($sMese >= 4)  and ($sGiorno >= 21)) or (($sMese <= 5) and ($sGiorno < 20)))
		$sSign = "Toro";
	else
	if ((($sMese >= 5)  and ($sGiorno >= 21)) or (($sMese <= 6) and ($sGiorno < 21)))
		$sSign = "Gemelli";
	else
	if ((($sMese >= 6)  and ($sGiorno >= 22)) or (($sMese <= 7) and ($sGiorno < 22)))
		$sSign = "Cancro";
	else
	if ((($sMese >= 7)  and ($sGiorno >= 23)) or (($sMese <= 8) and ($sGiorno < 23)))
		$sSign = "Leone";
	else
	if ((($sMese >= 8)  and ($sGiorno >= 24)) or (($sMese <= 9) and ($sGiorno < 22)))
		$sSign = "Vergine";
	else
	if ((($sMese >= 9)  and ($sGiorno >= 23)) or (($sMese <= 10) and ($sGiorno < 22)))
		$sSign = "Bilancia";
	else
	if ((($sMese >= 10)  and ($sGiorno >= 23)) or (($sMese <= 11) and ($sGiorno < 22)))
		$sSign = "Scorpione";
	else
	if ((($sMese >= 11)  and ($sGiorno >= 23)) or (($sMese <= 12) and ($sGiorno < 21)))
		$sSign = "Sagittario";
	
	return $sSign;
}

function getmonth($mese)
{

        if ($mese==1)  return "gennaio";
        else
        if ($mese==2)  return "febbraio";
        else
        if ($mese==3)  return "marzo";
        else
        if ($mese==4)  return "aprile";
        else
        if ($mese==5)  return "maggio";
        else
        if ($mese==6)  return "giugno";
        else
        if ($mese==7)  return "luglio";
        else
        if ($mese==8)  return "agosto";
        else
        if ($mese==9)  return "settembre";
        else
        if ($mese==10) return "ottobre";
        else
        if ($mese==11) return "novembre";
        else
        if ($mese==12) return "dicembre";
        else
        return "non definito";
}

function colorize(&$text) {
    global $color;

    $tc = count($text); $colorizedLast = false;
    for ($i=0; $i< $tc; ++$i) {
        $x = strpos(" ".$text[$i], "&gt;");
        if ($x > 0 && $x < 9) {
            if (!$colorizedLast) {
                $colorizedLast = true;
                $text[$i]="<font color=\"".$color["text_quoted"]."\">".$text[$i];
            }
        } else {
            if ($colorizedLast) {
                $colorizedLast = false;
                $text[$i]="</font>".$text[$i];
            }
        }
    }
}

?>