<?

// __log(): Logging Function
//          Expects: $string -> message to log
//                   $level  -> message importance
//          Returns: Nothing

function __log($string, $level)
 {
  global $__program;
  global $loglevel;
  global $logfile;

  $string = trim($string);
  $string = trim($string);

  if ($level <= $loglevel)
   {
   $msg = $level." ".date("Y/m/d H:i.s")." ".$__program." ".$string;
   echo $msg."\r\n";
   $flh = fopen ($logfile, "a");
   $rc = fwrite($flh, $msg."\n");
   fclose ($flh);
   }
 }

// getsize():   Get curret mailbox space usage
//              Expects: $string -> mailbox
//              Returns: Size of mailbox in KB

function getsize($string)
{
   $fp = popen("du ".$string, "r");
   $size = fgets($fp, 4096);
   pclose($fp);
   $size = explode("\t", $size);
   $s = $size[0];
   return $s;
}

// getsize():   Returns current mail size
//              Expects: $string -> mailbox
//              Returns: Size of mailbox in KB

function getmailsize($string)
{
   $fp = popen("du ".$string, "r");
   $size = fgets($fp, 4096);
   pclose($fp);
   $size = explode("\t", $size);
   $s = $size[0];
   return $s;
}

// checkvirus():Checks current mail for viruses
//              Expects: $file -> tempfile to scan
//              Returns: False if no virus if found, True if a virus if found

function checkvirus($file)
{

   global $__av;
   global $__pid;
   $cwd = getcwd();
   $tmpdir = "/TMP/".$__pid;

   __log("Checking For Viruses ".$file, 5);

//   $av_cmd_line = $__av["spawn"].' "'.eregi_replace("/", "\\", $__av["path"].$__av["program"]).' '.$__av["cmdline"].' '.eregi_replace("/", "\\", $file).' > Global.Txt"';
//   $av_cmd_line = eregi_replace("/", "\\", $__av["path"].$__av["program"]).' '.$__av["cmdline"].' '.eregi_replace("/", "\\", $file." > nul 2> errors.log");
   $av_cmd_line = eregi_replace("/", "\\", $__av["path"].$__av["program"]).' '.eregi_replace("/", "\\", $file).' '.$__av["cmdline"]." > nul 2> errors.log";

   __log("Spawning: ".$av_cmd_line, 3);

   chdir($__av["path"]);
//   system("echo ".$av_cmd_line." > Pippo.Bat");
//   system("Pippo.Bat", $errorlevel);
   system($av_cmd_line, $errorlevel);
   chdir($cwd);

   __log("Global VirusCheck: ".$errorlevel, 5);

   if ($errorlevel != 0)
    {
     __log("Infected Mail!".$errorlevel, 2);
     return 1;
    }
   else
    {
//  return 0;

    mkdir($tmpdir, 777);

    system("uudeview -i -a -m -p ".eregi_replace("/", "\\", $tmpdir)." ".$file." > nul 2> nul");

    __log("Checking For Viruses ".eregi_replace("/", "\\", $tmpdir."/*.*"), 5);

//    $av_cmd_line = $__av["spawn"].' "'.eregi_replace("/", "\\",$__av["path"].$__av["program"])." ".$__av["cmdline"]." ".eregi_replace("/", "\\", $tmpdir."/*.*").' > Inline.Txt"';
//    $av_cmd_line = eregi_replace("/", "\\",$__av["path"].$__av["program"])." ".$__av["cmdline"]." ".eregi_replace("/", "\\", $tmpdir."/*.*  > nul 2> errors.log");
    $av_cmd_line = eregi_replace("/", "\\", $__av["path"].$__av["program"]).' '.eregi_replace("/", "\\", $tmpdir."/*.* ").$__av["cmdline"]." > nul 2> errors.log";

    $cwd = getcwd();

    __log("Spawning: ".$av_cmd_line, 3);

    chdir($__av["path"]);
//    system("echo ".$av_cmd_line." > Pippo.Bat");
//    system("Pippo.Bat", $errorlevel);
    system($av_cmd_line, $errorlevel);
    chdir($cwd);

    system("DEL /N ".eregi_replace("/", "\\", $tmpdir."/*.*  > nul 2> nul"));
    rmdir($tmpdir);

    __log("Contents VirusCheck: ".$errorlevel, 5);

    if ($errorlevel != 0)
     {
      __log("Infected Mail!".$errorlevel, 2);
      return 1;
     }
    else
     {
     return 0;
     }

    }

}

// checkmail(): Check for Mail Validance
//              Expects: $string -> mail to check for
//              Returns: 2 if mail was handled ok
//                       1 if mail need treatment from weasel
//                       0 if mail need not to be handled

function checkmail($string)
 {
  global $buffer;
  global $from;

  $from = trim($from);
  $from = trim($from);

  while ($string != trim($string))
    $string = trim($string); 

  __log("[".$from."] --> [".$string."]", 2);

  $link = SK_db_connect();

  $ret = 2;
  $user = explode("@", $string);

  $dest_h = SK_db_query("SELECT * FROM users WHERE (user='".$user[0]."' AND domain='".$user[1]."') OR (user='*' AND domain='".$user[1]."') OR (user='".$user[0]."' AND domain='*')", $link);

  if (SK_db_querycount($dest_h) == 0)
   {
   $buffer = $buffer.$string."\r\n";
   return 0;
   }  
  else
   while ($dest = SK_db_array($dest_h))
    {
     $rc = parsemail($dest, $string, $from);
     if (($rc == "OK") AND ($ret == 2))
      $ret = 2;
     else
      $ret = 1;
    }

  __log(" Returning ".$ret, 5);
  return $ret;

 }


// parsemail(): Process a Mail Record
//              Expects: $array -> Mail record
//                       $recevice -> Original "to"
//                       $from -> Mail sender
//              Returns: "OK" if mail was handled ok
//                       "KO" if mail was not delivered (thus weasel should handle it)

function parsemail($array, $receiver, $from)
{

 global $__weasel;
 global $argv;

 if ($array["forward"] != "")
  {
   __log("Mail is a forward to ".$array["forward"], 4);
   $rc = checkmail($array["forward"]);
   if ($rc == 2)
    return "OK";
   else
    $buffer = $buffer.$forward."\r\n";
  }
 else
  {
   $pop = explode(".", strrev($array["user"].".".$array["domain"]), 2);
   $pop3 = $__weasel["maildir"]."/".strrev($pop[1]); 
   $_filename = explode("\\", strrev($argv[2]), 2);
   $filebase = substr(strrev($_filename[0]), 0, -3);

   if ($array["size"] > 0)
   {
    $size = getsize($pop3);
    __log("User using ".$size."kb out of ".$array["size"]."kb limit", 3);
   }
   else
    __log("Unlimited mailbox", 5);

   if (($array["size"] == 0) OR ($array["size"] >= $size))
   {
    copy($argv[1], $pop3."/".$filebase."MSG");
    __log("(".$pop3."/".$filebase."MSG)", 3);
    return "OK";
   }
   else
    {
     __log("Mail Trashed. Mailbox exceeding maximum size", 1);
     include("templates/mailboxfull.tpl");
     __sendmail($from, $body);
    }
  
  }

  return "KO";

}

////////// Mail Delivery Functions /////////
//

// __sendmail(): send a mail ... the __ is to avoid conflicts with PHP's one
//               expects: $to -> destination
//                        $body -> mail body
//               uses:    $__smtp -> global smtp settings;

function __sendmail($to, $body)
{

  global $__smtp;
  global $__program;

  $to = trim($to);

  $fp = fsockopen ($__smtp["server"], $__smtp["port"], $errno, $errstr, 30);

   if (($fp) AND ($to != "") AND ($to != "<>") AND ($to != "< >"))
   {
    __log("SMTP says: ".fgets($fp, 1024), 5);
    __log("We say hello :)", 5);
     fputs($fp, "HELO ".$__smtp["helo"]."\r\n");

    $checkin = fgets($fp, 1024);
    __log("SMTP says: ".$checkin, 5);
    if (substr($checkin, 0, 3) == "250")  
    {  
     __log($__smtp["from"]." speaking... :)", 5);
      fputs($fp, "MAIL FROM: <>\r\n");

      $checkin = fgets($fp, 1024);
      __log("SMTP says: ".$checkin, 5);
      if (substr($checkin, 0, 3) == "250")  
      {  
       __log("... is ".$to." at home?... :)", 5);
        fputs($fp, "RCPT TO: ".$to."\r\n");

        $checkin = fgets($fp, 1024);
        __log("SMTP says: ".$checkin, 5);
        if (substr($checkin, 0, 3) == "250")  
        {  
         __log("can I drop a line for him?", 5);
          fputs($fp, "DATA\r\n");

          $checkin = fgets($fp, 1024);
          __log("SMTP says: ".$checkin, 5);
          if (substr($checkin, 0, 3) == "354")  
          {  

           $header = "";
           $headers .= "MIME-Version: 1.0\r\n";
           $headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
           $headers .= "Content-Transfer-Encoding: 8bit\r\n";
           $headers .= "From: <mail service>\r\n"
                      ."Date: ".date("r")."\r\n"
                      ."To: ".$to."\r\n"
                      ."Return-Path: <>\r\n"
                      ."X-Mailer: ".$__program." - PHP/" . phpversion()."\r\n";

           __log("we deliver the message...", 5);
            fputs($fp, $headers);
            fputs($fp, $body);
            fputs($fp, "\n\r\n\r.\n\r");
            fputs($fp, "QUIT\n\r");
            fclose($fp);

          } else { __log("SMTP says he won't pick the message", 2); }
        } else { __log("SMTP says he never hear about ".$to, 2); }
      } else { __log("SMTP rejected our Mail Address!", 1); }
    } else { __log("SMTP rejected our HELO!", 1); }
   } else { __log("Unable to connect to SMTP server ".$__smtp["server"]."!!! ($errstr - $errno)", 1); }

}

////////// Mailing List Functions //////////
//


// major_process(): Let Majordomo take care of an email
//                  Expects: a mail
//                  Returns: nothing

?>