<?

///////////////////////////////////////////
//
// Prototipi di definizione per PostgreSQL
    //


function SK_db_error($string)
{

  die($string);

}


function SK_db_connect()   // Funzione di Connessione al Database
{

    global $sql;

    if ($sql["persistent"])
        $link = pg_Pconnect ("host=".$sql["server"]." user=".$sql["user"]." password=".$sql["password"]." dbname=".$sql["db_name"]);
    else
        $link = pg_Connect ("host=".$sql["server"]." user=".$sql["user"]." password=".$sql["password"]." dbname=".$sql["db_name"]);
    if (! $link)
        SK_db_error("Could not connect");
    return $link;
}



function SK_db_query($query, $link) // Funzione per l'esecuzione di una Query e ritorno di un pointer
{
    $result = pg_Exec($link, $query);
    if (! $result)
        SK_db_error("Invalid query: ".pg_ErrorMessage()." on ".$query);
    return $result;
}



function SK_db_array($result) // Funzione per l'esecuzione di una Query e ritorno di un Array
{
    $array = pg_Fetch_Array($result, 0);
    return $array;
}



function SK_db_simplequery($query) // Funzione per l'esecuzione di una Query e il ritorno del singolo risultato
{
    $result = SK_db_query($query);
    if (! $result)
        SK_db_error("Invalid query: ".mysql_error()." on ".$query);
    return pg_result($result, 0, 0);
}



function SK_db_querycount($result) // Funzione per sapere quanti record ha tirato fuori una query
{
    return pg_NumRows($result);
}



function SK_db_insert($table, $field, $value) // Funzione di inserimento generica
{

    $inf = count($field);
    $inv = count($value);

    if (! $inf == $inv)
        SK_db_error("Field / Value mismatch");

    $values = "";
    $fields = "";

    foreach($field as $f) {
        if (!empty($fields))
            $fields .= ', ';
        $fields .= $f;
    }

    foreach($value as $f) {
        if (!empty($values))
            $values .= ', ';
        $values .= $f;
    }

    $query = "INSERT INTO $table ($fields) values ($values)";

    SK_db_query($query);

}


?>
